#include <stdio.h>

#include "utils.h"

#ifdef HEARTBEAT_BIT
void HeartBeat(void)
{
    static u_char beat;

    if ((beat = !beat) == 0) {
        cbi(HEARTBEAT_PORT, HEARTBEAT_BIT);
    }
    else {
        sbi(HEARTBEAT_PORT, HEARTBEAT_BIT);
    }
    sbi(HEARTBEAT_DDR, HEARTBEAT_BIT);
}
#endif

/*!
 * \brief Delay by executing a given number of NOPs.
 *
 * parm nops 2,000,000 is roughly 1 second.
 */
void Delay(long nops)
{
    long i;

    for (i = 0; i < nops; i++) {
#ifdef HEARTBEAT_BIT
        if ((i & 0xFF) == 0) {
            HeartBeat();
        }
#else
        _NOP();
#endif
    }
}

int hex2bin(char c)
{
    if (c >= '0' && c <= '9')
        return c - '0';
    if (c >= 'a' && c <= 'f')
        return c - 'a' + 10;
    if (c >= 'A' && c <= 'F')
        return c - 'A' + 10;
    return 0;
}

